/********************************************************************************
 * Copyright (c) 2023 Mettenmeier GmbH
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/
package org.eclipse.openk.sp.controller.pseudonymization;



import java.util.HashSet;
import java.util.Set;



/**
 * Convenience class for splitting sets.
 */
public class SetIntersection<T>
{

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Constants
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Variables
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	public Set<T> intersectSet;
	public Set<T> extraA;
	public Set<T> extraB;

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Constructors
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Constructor.
	 */
	private SetIntersection(Set<T> setA, Set<T> setB)
	{
		intersectSet = new HashSet<>(setA);
		intersectSet.retainAll(setB);

		extraA = new HashSet<>(setA);
		extraA.removeAll(setB);

		extraB = new HashSet<>(setB);
		extraB.removeAll(setA);
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Helper Methods
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Public Getters/Setters
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Public Methods
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Static Methods
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Perform an intersection between two sets. For convenience the result object provides common values and differences.
	 */
	public static <T> SetIntersection<T> intersect(Set<T> setA, Set<T> setB)
	{
		return new SetIntersection<>(setA, setB);
	}

}




